music('deepsparse.ogg')
box1=walls([(0, 0), (0, 500), (250, 500), 'box1out', (450, 500), (700, 500),
            (700, 0), (350+26, 0), 'box1in', (350-26, 0)],
           pos=(0, 900), counter=True, closed=True, texture="humanwall")
b1idoor = door(box1, 'box1in')
startpattern = [((0, 10), 90), ((0, 0), -1), 'delete(self,"bottom")',
                'b1idoor.open()']
p = Player(pos=(100, 100))
startbox = package(payload=p, pattern=startpattern,
                   rel=('top', box1), pos=(350-26, -900), texture="humanboxwall", bg='humanboxbg')
circle(20, pos=(350, 1150), static=True)
b1odoor = door(box1, 'box1out')
s = switch(shapes=[Circle(8)], pos=(250, 1400), action=['b1odoor.open()', 'set_flag("switch1", True)'])

crushbox = walls([(400, 0), (0,0), (0, 400), (400, 400)], counter=True, rel=('bottom', box1), pos=(-150, 0), texture='humanwall')
crushargs = {'rel':crushbox, 'texture':'humanwall'}
crushrighttopwall = walls([(600-THICKNESS, -THICKNESS), (600-THICKNESS, 400+THICKNESS)], **crushargs)
crushrightinswall = walls([(600-THICKNESS, 200), (200, 200)], **crushargs)

downpat = [((0, 5), 40), ((0, 0), 0), ((0, -5), 40), ((0, 0), 0), Repeat]
uppat = mirror_y(downpat)

topcrush = walls([(0, 0), (200, 0)], pattern=downpat, rel=crushbox, texture='humanwall')
botcrush = walls([(0, 400), (200, 400)], counter=True, pattern=uppat, rel=crushbox, texture='humanwall')

tunnelargs = {'rel':topcrush, 'pos':(400, 400), 'texture':'humanwall'}
tunnelright = walls([(200-THICKNESS, 0), (200-THICKNESS, 200)], **tunnelargs)
tunnelleft = walls([(200, 400), (0, 400), (0, 0)], **tunnelargs)

room2 = walls([(0, 400), (0, 0), (800, 0), (800, 600), 'room2out', (700, 600),
               (0, 600)],
              rel=[('right', tunnelleft), ('bottom', tunnelleft, 'bottom')],
              pos=(-2*THICKNESS, 0), texture='humanwall', bg='trainingbg2')
e1ai = ai.Leads(period=40, turnrate=1, strength=40)
e1 = enemy(ai=ai.Stationary(),
          shapes=[Circle(8, image="drone")], pos=(28, 300), rel=room2,
          size=8, health=None, static=True, angle=270)

shelter = walls([(200, 300), (200, 200), (300, 200), (300, 300)],
                rel=room2)

shelter2 = walls([(520, 600), (520, 400)], rel=room2)

r2odoor = door(room2, 'room2out')
s2 = switch(shapes=[Circle(8)], pos=(800, 400), rel=room2, action=['r2odoor.open()'])

room3 = walls([(100, 0), (100, 100), (0, 100), (0, 400), (300, 400),
               (300, 100), (200, 100), (200, 0)],
              rel=room2, pos=(600, 600), counter=True, texture='humanwall')

e2dist = 600-24
e2ai=ai.Shoots()
e2 = enemy(ai=ai.Stationary(), shapes=[Circle(8, image="drone")], pos=(500, 12),
           rel=room2, angle=180, static=True, health=None,
           pattern=[((0, e2dist/72), 72), ((0, -e2dist/72), 72), Repeat])

dialog("One more thing you might like to know about is the pull beam. This room is for you to play with it and get used to it.", characters.Sargeant)
dialog("To use the pull beam, shoot with the S key.")
dialog("To unhook it, press S again.")
dialog("There's a switch on the south wall. Hit it when you're ready to move on.", characters.Sargeant)
flag('switch1')
ds = Sequence(Dialog("Getting past this crusher is tough, but the pull beam should help.", characters.Sargeant))
objectin(p, (-200, 200, 200, 400), rel=room2, meanwhile=ds)
e1.ai = e1ai
e2.ai = e2ai

objectin(p, (0, 100, 300, 300), rel=room3, meanwhile=Sequence(
    Dialog("Now just zip through this last room.", characters.Sargeant)))
    
dialog("Nice going. Before long you may be a real pilot!", characters.Sargeant)
